(function(f){if(typeof exports==="object"&&typeof module!=="undefined"){module.exports=f()}else if(typeof define==="function"&&define.amd){define([],f)}else{var g;if(typeof window!=="undefined"){g=window}else if(typeof global!=="undefined"){g=global}else if(typeof self!=="undefined"){g=self}else{g=this}g.module = f()}})(function(){var define,module,exports;return (function(){function r(e,n,t){function o(i,f){if(!n[i]){if(!e[i]){var c="function"==typeof require&&require;if(!f&&c)return c(i,!0);if(u)return u(i,!0);var a=new Error("Cannot find module '"+i+"'");throw a.code="MODULE_NOT_FOUND",a}var p=n[i]={exports:{}};e[i][0].call(p.exports,function(r){var n=e[i][1][r];return o(n||r)},p,p.exports,r,e,n,t)}return n[i].exports}for(var u="function"==typeof require&&require,i=0;i<t.length;i++)o(t[i]);return o}return r})()({1:[function(require,module,exports){

const DEBUG=true;

const events = {
    update: function(ui) {
      console.log("general update");
      initializeAll(ui, this);
    },

    onChange_factors: function(ui) {
         updateSuppliers(ui,this);
         updateContrasts(ui,this);
    },

    onChange_endogenous: function(ui) {
       prepareEndogenousTerms(ui,this);
       updateSuppliers(ui,this);
       updateScaling(ui,this);

    },

    onChange_covariates: function(ui) {
        updateSuppliers(ui,this);
        updateScaling(ui,this)
        
    },


    onChange_endogenousSupplier: function(ui) {
       log("endogenousSupplier has changed");
       cleanEndogenousTerms(ui, this);
//       fromSupplierToEndogenousTerms(ui, this);

    },

    onUpdate_endogenousSupplier: function(ui) {
            log("endogenousSupplier update");
            let factorsList = this.cloneArray(ui.factors.value(), []);
            let covariatesList = this.cloneArray(ui.covs.value(), []);
            var variablesList = factorsList.concat(covariatesList);
            ui.endogenousSupplier.setValue(this.valuesToItems(variablesList, FormatDef.variable));

    },

     onChange_endogenousTerms: function(ui) {
      cleanRecursiveTerms(ui,this);
    },


     onEvent_nothing: function(ui) {
      console.log("I did not do anything");
    },

     onChange_nothing: function(ui) {
      console.log("I did not do anything");
    },
    onChange_varcovSupplier: function(ui) {
      console.log("varcovsup change");
       let values = this.itemsToValues(ui.varcovSupplier.value());
        this.checkPairsValue(ui.varcov, values);
      
    },
    onUpdate_varcovSupplier: function(ui) {
      console.log("varcovsup update");
      
    },


};



var initializeAll = function(ui, context) {
    
    updateSuppliers(ui,context);
    prepareEndogenousTerms(ui,context);

};




var updateSuppliers= function(ui,context) {

   // here we transfer all variables in the supplier for the endogenous models
   
    var factorsList = context.cloneArray(ui.factors.value(), []);
    var covariatesList = context.cloneArray(ui.covs.value(), []);
    var indList = factorsList.concat(covariatesList);
    var endogenousList = context.cloneArray(ui.endogenous.value(), []);
    var allList = factorsList.concat(covariatesList).concat(endogenousList);
    ui.endogenousSupplier.setValue(context.valuesToItems(allList, FormatDef.variable));
    ui.varcovSupplier.setValue(context.valuesToItems(allList, FormatDef.variable));
    context.workspace.endogenousSupplierList=allList;
    context.workspace.varcovSupplierList=allList;
    

};

var prepareEndogenousTerms= function(ui,context) {

     // here we prepare a list of lists, one of each endogenous variable.
     // we also want to put a label to show which dependent variable the user is working on

     console.log("prepareEndogenousTerms");
     var endogenous = context.cloneArray(ui.endogenous.value(),[]);
     var endogenousTerms = context.cloneArray(ui.endogenousTerms.value(),[]);
     
 
     // we make sure that there are enough arrays in the array list, each for each endogeneous
     var okList= [];
     for (var i = 0; i < endogenous.length; i++) {
         var aList = endogenousTerms[i] === undefined ? [] : endogenousTerms[i] ;
             okList.push(aList);
     }
      console.log(okList);
      ui.endogenousTerms.setValue(okList);    
      
     // we give a label for each endogeneous model
     labelize(ui.endogenousTerms,endogenous, "Endogenous");  
     storeComponent("endogenousTerms",endogenousTerms,context);
  
  
};


var cleanRecursiveTerms= function(ui,context) {

    console.log("cleanRecursiveTerms");
    var endogenous = context.cloneArray(ui.endogenous.value(), []);
    var endogenousTerms = context.cloneArray(ui.endogenousTerms.value(),[]);

    for (var i = 0; i < endogenous.length; i++)
        endogenousTerms[i]=removeFromList(endogenous[i],endogenousTerms[i],context,1);

    for (var i = 0; i < endogenousTerms.length; i++) {
       for (var j = 0; j < endogenousTerms[i].length; j++) {
         endogenousTerms[i][j].sort();
       }
      
    }
        
    ui.endogenousTerms.setValue(endogenousTerms);
    storeComponent("endogenousTerms",endogenousTerms,context);

};


var cleanEndogenousTerms= function(ui,context) {

    console.log("cleanEndogenousTerms");
    var endogenous = context.cloneArray(ui.endogenous.value(), []);
    var endogenousTerms = context.cloneArray(ui.endogenousTerms.value(),[]);

    for (var i = 0; i < endogenous.length; i++)
        endogenousTerms[i]=removeFromList(endogenous[i],endogenousTerms[i],context,1);

    var endogenousSupplierList = context.cloneArray(context.itemsToValues(ui.endogenousSupplier.value()),[]);
    var diff = context.findChanges("endogenousSupplierList",endogenousSupplierList,context);
    if (diff.hasChanged) {
      for (var i = 0; i < endogenous.length; i++) 
           for (var j = 0; j < diff.removed.length; j++) {
                console.log(diff.removed[j]);
                endogenousTerms[i]=removeFromList(diff.removed[j],endogenousTerms[i],context,1);
           }
           
    }
    ui.endogenousTerms.setValue(endogenousTerms);
    storeComponent("endogenousTerms",endogenousTerms,context);

};






var updateScaling = function(ui,context) {
    log("updateScaling");
    var currentList = context.cloneArray(ui.scaling.value(), []);
    var variableList1 = context.cloneArray(ui.covs.value(), []);
    var variableList2 = context.cloneArray(ui.endogenous.value(), []);
    var variableList = variableList2.concat(variableList1);

    var list3 = [];
    for (let i = 0; i < variableList.length; i++) {
        let found = null;
        for (let j = 0; j < currentList.length; j++) {
            if (currentList[j].var === variableList[i]) {
                found = currentList[j];
                break;
            }
        }
        if (found === null)
            list3.push({ var: variableList[i], type: "none" });
        else
            list3.push(found);
    }

    ui.scaling.setValue(list3);
};

var updateContrasts = function(ui, context) {
    var currentList = context.cloneArray(ui.contrasts.value(), []);
    var variableList = context.cloneArray(ui.factors.value(), [])
    var list3 = [];
    for (let i = 0; i < variableList.length; i++) {
        let found = null;
        for (let j = 0; j < currentList.length; j++) {
            if (currentList[j].var === variableList[i]) {
                found = currentList[j];
                break;
            }
        }
        if (found === null)
            list3.push({ var: variableList[i], type: "simple" });
        else
            list3.push(found);
    }

    ui.contrasts.setValue(list3);
};



// helper functions

// add an item or a list of items (quantum) to a list (cosmos).
// it tries to understand what kind of input it has, but it is not clear
// when it works
var addToList = function(quantum, cosmos, context) {
  
    cosmos = normalize(context.cloneArray(cosmos));
    quantum = normalize(context.cloneArray(quantum));
    
    for (var i = 0; i < quantum.length; i++) {
          if (dim(quantum[i])===0)
              cosmos.push([quantum[i]]);
          if (dim(quantum[i])===1)
              cosmos.push(quantum[i]);
          }
    return unique(cosmos);
};


var removeFromMultiList = function(quantum, cosmos, context, strict = 1) {

    var cosmos = context.cloneArray(cosmos);
    var dimq = dim(quantum);
        for (var j = 0; j < cosmos.length; j++) 
           cosmos[j]=removeFromList(quantum,cosmos[j],context, strict);
    return(cosmos);
};



// remove a list or a item from list
// order=0 remove only if term and target term are equal
// order>0 remove if term length>=order 
// for instance, order=1 remove any matching interaction with terms, keeps main effects
// order=2 remove from 3-way interaction on (keep up to 2-way interactions)

var removeFromList = function(quantum, cosmos, context, order = 1) {

     cosmos=normalize(cosmos);
     quantum=normalize(quantum);
     if (cosmos===undefined)
        return([]);
     var cosmos = context.cloneArray(cosmos);
       for (var i = 0; i < cosmos.length; i++) {
          if (cosmos[i]===undefined)
             break;
          var aCosmos = context.cloneArray(cosmos[i]);
           for (var k = 0; k < quantum.length; k++) {
             var  test = order === 0 ? FormatDef.term.isEqual(aCosmos,quantum[k]) : FormatDef.term.contains(aCosmos,quantum[k]);
                 if (test && (aCosmos.length >= order)) {
                        cosmos.splice(i, 1);
                        i -= 1;
                    break;    
                    }
          }
            
       }
  
    return(cosmos);
};




var unique=function(arr) {
    var u = {}, a = [];
    for(var i = 0, l = arr.length; i < l; ++i){
        var prop=ssort(JSON.stringify(arr[i]));
        if(!u.hasOwnProperty(prop) && arr[i].length>0) {
            a.push(arr[i]);
            u[prop] = 1;
        }
    }
    return a;
};

var ssort= function(str){
  str = str.replace(/[`\[\]"\\\/]/gi, '');
  var arr = str.split(',');
  var sorted = arr.sort();
  return sorted.join('');
}

var labelize = function(widget, labels, prefix) {

     widget.applyToItems(0, (item, index) => {
           item.controls[0].setPropertyValue("label",prefix +" = "+labels[index]);
        });
};


var flatMulti = function(cosmos,context) {
  var light = []
  for (var i=0 ; i < cosmos.length; i++) {
    light=addToList(light,cosmos[i],context);
  }
  return unique(light);
};

var combineOne = function(values, mod, context) {
        if (mod===undefined)
            return(values);
        var list = unique(values.concat([mod]));
        for (var i = 0; i < values.length; i++) {
            var newValue = context.clone(mod);
            var value = values[i];
            if (context.listContains(value,newValue[0],FormatDef.term)===false)
                   if (FormatDef.term.isEqual(newValue,value)===false) {
                      if (Array.isArray(value)) 
                          newValue = newValue.concat(value);
                      else
                         newValue.push(value);   
            list.push(newValue);
            }
        }
        return unique(list);
};

var getInteractions = function(aList,context,order=2) {
  
  var iList = context.getCombinations(aList);
  for (var i = 0; i < iList.length; i++ )
          if (iList[i].length===1 || iList[i].length>order) {
              iList.splice(i, 1);
               i -= 1;
          }
 return(iList);
  
};

var normalize = function(cosmos) {

  if (cosmos===undefined)
          return [];
  if (dim(cosmos)===0)
          cosmos=[cosmos]
          
        for (var i = 0; i < cosmos.length; i++) {
            var aValue = cosmos[i];
            var newValue=dim(aValue)>0 ? aValue : [aValue];
            cosmos[i]=newValue
        }
        return cosmos;
}

// get interaction between two lists
// order==0 include main effects
// 1  only interaction


var combine = function(cosmos1, cosmos2 , context, order=2) {
        if (cosmos1===cosmos2)
               return;
        if (cosmos1===undefined)
               return order===0 ? cosmos2 : [] ;
        if (cosmos2===undefined)
               return order===0 ? cosmos1 : [] ;
        cosmos1 = normalize(cosmos1)
        cosmos2 = normalize(cosmos2)        

        var light=[];
        for (var i = 0; i < cosmos1.length; i++) {
            var aValue1 = context.clone(cosmos1[i]);
            for (var j = 0 ; j < cosmos2.length; j ++) {
            var aValue2 = context.clone(cosmos2[j]);
            var join = aValue1.concat(aValue2);
            if (join.length===unique(join).length)
                   light.push(join);
              }
            }

        if (order===0)
              light = cosmos1.concat(cosmos2).concat(light);
        return unique(light);
};


var dim = function(aList) {

    if (!Array.isArray(aList))
           return(0);
    if (!Array.isArray(aList[0]))
           return(1);
    if (!Array.isArray(aList[0][0]))
           return(2);
    if (!Array.isArray(aList[0][0][0]))
           return(3);
    if (!Array.isArray(aList[0][0][0][0]))
           return(4);

  
    return(value);
};

var findChangesMulti= function(id,cosmos,context,save=true) {

  var old = context.workspace[id];
 if (old===undefined)
        old=[];
      
  var light = [];
  var len = Math.max(cosmos.length,old.length);
  var changeIndex = -1;
  for (var i = 0; i < len; i++) {
    var photon=[];
    photon.added = removeFromList(old[i], cosmos[i], context, 0);
    photon.removed = removeFromList(cosmos[i],old[i], context, 0);
    if  (photon.added.length > 0 || photon.removed.length > 0) 
          changeIndex = i
    light[i] = photon;
}
  light = { changes: light, index: changeIndex };
  if (save)
        storeComponent(id,cosmos,context);
  return(light);
};

var storeComponent = function(id,cosmos,context) {
                    context.workspace[id]=cosmos;
};

var log=function(obj) {
    if (DEBUG)
      console.log(obj);
};

var dlog=function(obj) {
    if (DEBUG)
      console.log(obj);
};

var flashMGridOptionListControl = function(widget,note=false) {
        var i =widget.getSelectedRowIndices();
        if (i.length==0) i=0;
        widget.controls[i].controls[1].$el[0].style.backgroundColor="#ffcccc";
        widget.controls[i].controls[1].$el[0].style.borderColor="red";
        if (note!==false)
           note.$el[0].style.visibility="visible";
        

};

var unflashMGridOptionListControl = function(widget,note=false) {
        var i =widget.getSelectedRowIndices();
        if (i.length==0) i=0;
        widget.controls[i].controls[1].$el[0].style.backgroundColor="white";
        widget.controls[i].controls[1].$el[0].style.borderColor="rgb(46,138,199)";
        if (note!==false)
           note.$el[0].style.visibility="hidden";
};

var   cleanInteractions= function(quantum,cosmos,context){
  if (quantum===undefined)
    return(cosmos);
    
  var deny= context.getCombinations(quantum)  
  for (var i=0; i < deny.length; i++) {
    if (deny[i].length==1) {
      deny.splice(i, 1);
      i -= 1;
    }
  }
  cosmos=context.cloneArray(cosmos)
  for (var j=0; j< cosmos.length; j++) {
    for (var i=0; i < deny.length; i++) {
      if (FormatDef.term.contains(cosmos[j],deny[i])) {
        cosmos.splice(j,1);
        j -= 1;
        break;
      }
  }
}
 return cosmos;
  
};


module.exports = events;


},{}],2:[function(require,module,exports){

// This file is an automatically generated and should not be edited

'use strict';

const options = [{"name":"data","type":"Data","description":{"R":"the data as a data frame"}},{"name":"endogenous","title":"Endogenous Variables","type":"Variables","suggested":["continuous","ordinal"],"permitted":["numeric"],"default":null,"description":{"R":"a vector of strings naming the mediators from `data`"}},{"name":"factors","title":"Exogenous Factors","type":"Variables","suggested":["nominal","ordinal"],"permitted":["factor"],"default":null,"description":{"R":"a vector of strings naming the fixed factors from `data`"}},{"name":"covs","title":"Exogenous Covariates","type":"Variables","suggested":["continuous","ordinal"],"permitted":["numeric"],"default":null,"description":{"R":"a vector of strings naming the covariates from `data`"}},{"name":"multigroup","title":"Multigroup Analysis Factor","type":"Variable","suggested":["nominal","ordinal"],"permitted":["factor"],"default":null,"description":{"R":"factor defining groups for multigroup analysis"}},{"name":"tests","type":"NMXList","options":[{"name":"Satorra.Bentler","title":"Satorra-Bentler"},{"name":"Yuan.Bentler","title":"Yuan Bentler"},{"name":"Satterthwaite","title":"Satterthwaite"}],"default":null},{"name":"se","title":"Standard errors","type":"List","options":[{"name":"standard","title":"Standard"},{"name":"robust.sem","title":"Robust (Conventional)"},{"name":"robust.huber.white","title":"Robust (Huber-White)"},{"name":"boot","title":"Bootstrap"}],"default":"standard"},{"name":"r2ci","title":"R-squared C.I","type":"List","options":[{"name":"fisher","title":"Z-to-r transform"},{"name":"model","title":"Residual C.I."}],"default":"fisher","description":{"R":"Choose the confidence interval type\n"}},{"name":"r2test","title":"R-squared tests","type":"Bool","default":false},{"name":"bootci","title":"Bootstrap C.I","type":"List","options":[{"name":"perc","title":"Percentiles"},{"name":"bca.simple","title":"Adjusted bias corrected"},{"name":"norm","title":"Normal"},{"name":"basic","title":"Basic"}],"default":"perc","description":{"R":"Choose the confidence interval type\n"}},{"name":"ci","title":"Show","type":"Bool","default":true},{"name":"ciWidth","title":"Confidence level","type":"Number","min":50,"max":99.9,"default":95,"description":{"R":"a number between 50 and 99.9 (default: 95) specifying the confidence interval width for the parameter estimates\n"}},{"name":"bootN","title":"Bootstrap Rep.","type":"Number","min":50,"default":1000,"description":{"R":"number of bootstrap samples for estimating confidence intervals\n"}},{"name":"showintercepts","title":"Show intercepts estimates","type":"Bool","default":true,"description":{"R":"`TRUE` or `FALSE` (default), show intercepts\n"}},{"name":"intercepts","title":"Estimates intercepts","type":"Bool","default":true,"description":{"R":"`TRUE` or `FALSE` (default), show intercepts\n"}},{"name":"indirect","title":"Indirect Effects","type":"Bool","default":false,"description":{"R":"`TRUE` or `FALSE` (default), show intercepts\n"}},{"name":"contrasts","title":"Factors Coding","type":"Array","items":"(factors)","default":null,"template":{"type":"Group","elements":[{"name":"var","type":"Variable","content":"$key"},{"name":"type","type":"List","options":["simple","deviation","dummy","difference","helmert","repeated","polynomial"],"default":"simple"}]},"description":{"R":"a list of lists specifying the factor and type of contrast to use, one of `'deviation'`, `'simple'`, `'difference'`, `'helmert'`, `'repeated'` or `'polynomial'`\n"}},{"name":"showContrastCode","title":"Contrast Coefficients tables","type":"Bool","default":false,"description":{"R":"`TRUE` or `FALSE` (default), provide contrast coefficients tables\n"}},{"name":"scaling","title":"Continuous Variables Scaling","type":"Array","default":null,"template":{"type":"Group","elements":[{"name":"var","type":"Variable","content":"$key"},{"name":"type","type":"List","options":[{"title":"None","name":"none"},{"title":"Centered","name":"centered"},{"title":"z-scores","name":"standardized"},{"title":"Log","name":"log"}],"default":"none"}]},"description":{"R":"a named vector of the form \\code{c(var1='type', var2='type2')} specifying the transformation to apply to covariates, one of `'centered'` to the mean, `'standardized'`,`'log'` or  `'none'`. `'none'` leaves the variable as it is.\n"}},{"name":"endogenousTerms","title":"Models for Endogenous Vars","type":"Array","default":[[]],"template":{"type":"Terms"},"description":{"R":"a list of lists specifying the models for with the mediators as dependent variables.          \n"}},{"name":"diagram","title":"Path Diagram","type":"Bool","default":false,"description":{"R":"`TRUE` or `FALSE` (default), produce a path diagram\n"}},{"name":"diag_paths","title":"Paths Labels","type":"List","options":[{"name":"est","title":"Coefficients"},{"name":"stand","title":"Betas"},{"name":"name","title":"Labels"},{"name":"hide","title":"None"}],"default":"est","description":{"R":"Choose the diagram labels\n"}},{"name":"diag_resid","title":"Residuals","type":"Bool","default":false,"description":{"R":"`TRUE` or `FALSE` (default), produce a path diagram\n"}},{"name":"diag_offset_labs","title":"Offset labels","type":"Bool","default":false,"description":{"R":"`TRUE` or `FALSE` (default), offset labels position\n"}},{"name":"diag_labsize","title":"Node Size","type":"List","options":[{"name":"small","title":"Small"},{"name":"medium","title":"Medium"},{"name":"large","title":"Large"},{"name":"vlarge","title":"Very Large"}],"default":"medium","description":{"R":"Choose the diagram labels\n"}},{"name":"diag_rotate","title":"Rotate","type":"List","options":[{"name":"1","title":"Exog. top"},{"name":"2","title":"Exog. left"},{"name":"3","title":"Exog. bottom"},{"name":"4","title":"Exog. right"}],"default":"2","description":{"R":"Choose the diagram labels\n"}},{"name":"diag_type","title":"Type","type":"List","options":[{"name":"mediation","title":"Mediation-like"},{"name":"tree","title":"Tree-like"},{"name":"tree2","title":"Tree-like alt."},{"name":"circle","title":"Circle"},{"name":"circle2","title":"Circle alt."},{"name":"spring","title":"Spring"}],"default":"mediation","description":{"R":"Choose the diagram labels\n"}},{"name":"diag_shape","title":"Shapes","type":"List","options":[{"name":"rectangle","title":"Rectangles"},{"name":"square","title":"Squares"},{"name":"circle","title":"Circles"},{"name":"ellipse","title":"Ellipses"},{"name":"diamond","title":"Diamonds"}],"default":"rectangle","description":{"R":"Choose the diagram labels\n"}},{"name":"diag_abbrev","title":"Abbreviate","type":"List","options":[{"name":"0","title":"No abbrev."},{"name":"5","title":"5"},{"name":"10","title":"10"},{"name":"15","title":"15"},{"name":"20","title":"20"},{"name":"25","title":"25"}],"default":"0","description":{"R":"Choose the diagram labels\n"}},{"name":"varcov","title":"Select pairs","type":"Pairs","description":{"R":"a list of lists specifying the  covariances that need to be estimated\n"}},{"name":"cov_y","title":"Endogenous Correlations","type":"Bool","default":true,"description":{"R":"`TRUE` or `FALSE` (default), produce a path diagram\n"}},{"name":"cov_x","title":"Fixed Exogenous","type":"Bool","default":true,"description":{"R":"`TRUE` or `FALSE` (default), produce a path diagram\n"}},{"name":"constraints","title":"Insert contraints or defined parameters","type":"Array","default":[],"template":{"type":"String"},"description":{"R":"a list of lists specifying the models random effects.          \n"}},{"name":"constraints_examples","type":"Bool","title":"Show Examples","default":false},{"name":"showlabels","type":"Bool","title":"Show parameters labels","default":false},{"name":"scoretest","type":"Bool","title":"Univariate","default":true},{"name":"cumscoretest","type":"Bool","title":"Cumulative","default":false},{"name":"estimator","title":"Method","type":"List","options":[{"name":"ML","title":"Maximum Likelihood"},{"name":"GLS","title":"Generalized least squares"},{"name":"WLS","title":"Weighted LS"},{"name":"DWLS","title":"Diagonally weighted LS"},{"name":"ULS","title":"Unweighted LS"}],"default":"ML","description":{"R":"Choose the diagram labels\n"}},{"name":"likelihood","title":"ML likelihood approach","type":"List","options":[{"name":"normal","title":"Normal"},{"name":"wishart","title":"Wishart"}],"default":"normal","description":{"R":"Choose the diagram labels\n"}},{"name":"group.equal","type":"NMXList","options":[{"name":"intercepts","title":"Intercepts"},{"name":"residuals","title":"Residual variances"},{"name":"residual.covariances","title":"Residual covariances"},{"name":"regressions","title":"regression coefficients"}],"default":null}];

const view = function() {
    
    

    View.extend({
        jus: "2.0",

        events: [

	],

	update: require('./pathj.events').update

    }).call(this);
}

view.layout = ui.extend({

    label: "Path Analysis",
    jus: "2.0",
    type: "root",
    stage: 0, //0 - release, 1 - development, 2 - proposed
    controls: [
		{
			type: DefaultControls.VariableSupplier,
			typeName: 'VariableSupplier',
			name: "variablesupplier",
			suggested: ["continuous","nominal","ordinal"],
			persistentItems: false,
			stretchFactor: 1,
			controls: [
				{
					type: DefaultControls.TargetLayoutBox,
					typeName: 'TargetLayoutBox',
					controls: [
						{
							type: DefaultControls.VariablesListBox,
							typeName: 'VariablesListBox',
							name: "endogenous",
							isTarget: true,
							events: [
								{ execute: require('./pathj.events').onChange_endogenous }
							]
						}
					]
				},
				{
					type: DefaultControls.TargetLayoutBox,
					typeName: 'TargetLayoutBox',
					controls: [
						{
							type: DefaultControls.VariablesListBox,
							typeName: 'VariablesListBox',
							name: "factors",
							isTarget: true,
							events: [
								{ execute: require('./pathj.events').onChange_factors }
							]
						}
					]
				},
				{
					type: DefaultControls.TargetLayoutBox,
					typeName: 'TargetLayoutBox',
					controls: [
						{
							type: DefaultControls.VariablesListBox,
							typeName: 'VariablesListBox',
							name: "covs",
							isTarget: true,
							events: [
								{ execute: require('./pathj.events').onChange_covariates }
							]
						}
					]
				},
				{
					type: DefaultControls.TargetLayoutBox,
					typeName: 'TargetLayoutBox',
					controls: [
						{
							type: DefaultControls.VariablesListBox,
							typeName: 'VariablesListBox',
							name: "multigroup",
							maxItemCount: 1,
							isTarget: true,
							itemDropBehaviour: "overwrite"
						}
					]
				}
			]
		},
		{
			type: DefaultControls.CollapseBox,
			typeName: 'CollapseBox',
			label: "Endogenous Models",
			collapsed: true,
			stretchFactor: 1,
			controls: [
				{
					type: DefaultControls.LayoutBox,
					typeName: 'LayoutBox',
					margin: "large",
					stretchFactor: 1,
					controls: [
						{
							type: DefaultControls.Supplier,
							typeName: 'Supplier',
							name: "endogenousSupplier",
							format: FormatDef.term,
							persistentItems: true,
							stretchFactor: 1,
							events: [
								{ onEvent: 'update', execute: require('./pathj.events').onChange_endogenousSupplier },
								{ execute: require('./pathj.events').onChange_endogenousSupplier }
							],
							controls: [
								{
									type: DefaultControls.TargetLayoutBox,
									typeName: 'TargetLayoutBox',
									transferAction: "interactions",
									controls: [
										{
											type: DefaultControls.ListBox,
											typeName: 'ListBox',
											name: "endogenousTerms",
											height: "large",
											selectable: true,
											templateName: "linreg-block-template",
											template:
											{
												type: DefaultControls.LayoutBox,
												typeName: 'LayoutBox',
												margin: "normal",
												targetArea: true,
												controls: [
													{
														type: DefaultControls.Label,
														typeName: 'Label',
														label: "empty",
														name: "blockName",
														stretchFactor: 1,
														margin: "normal"
													},
													{
														type: DefaultControls.ListBox,
														typeName: 'ListBox',
														enable: "(endogenous)",
														name: "blockList",
														isTarget: true,
														valueFilter: "unique",
														height: "auto",
														ghostText: "drag variables here",
														events: [
															{ execute: require('./pathj.events').onChange_endogenousTerms }
														],
														template:
														{
															type: DefaultControls.TermLabel,
															typeName: 'TermLabel'
														}														
													}
												]
											}											
										}
									]
								}
							]
						}
					]
				}
			]
		},
		{
			type: DefaultControls.CollapseBox,
			typeName: 'CollapseBox',
			label: "Variances and Covariances",
			collapsed: true,
			stretchFactor: 1,
			controls: [
				{
					type: DefaultControls.LayoutBox,
					typeName: 'LayoutBox',
					margin: "large",
					style: "inline",
					stretchFactor: 1,
					controls: [
						{
							type: DefaultControls.VariableSupplier,
							typeName: 'VariableSupplier',
							name: "varcovSupplier",
							populate: "manual",
							persistentItems: true,
							stretchFactor: 1,
							events: [
								{ execute: require('./pathj.events').onChange_varcovSupplier },
								{ onEvent: 'update', execute: require('./pathj.events').onUpdate_varcovSupplier }
							],
							controls: [
								{
									type: DefaultControls.TargetLayoutBox,
									typeName: 'TargetLayoutBox',
									label: "Select pairs",
									controls: [
										{
											type: DefaultControls.VariablesListBox,
											typeName: 'VariablesListBox',
											name: "varcov",
											fullRowSelect: true,
											isTarget: true,
											columns: [
												{
													name: "i1",
													stretchFactor: 1,
													template:
													{
														type: DefaultControls.VariableLabel,
														typeName: 'VariableLabel'
													}													
												},
												{
													name: "i2",
													stretchFactor: 1,
													template:
													{
														type: DefaultControls.VariableLabel,
														typeName: 'VariableLabel'
													}													
												}
											]
										}
									]
								}
							]
						}
					]
				},
				{
					type: DefaultControls.LayoutBox,
					typeName: 'LayoutBox',
					margin: "large",
					style: "inline",
					controls: [
						{
							type: DefaultControls.Label,
							typeName: 'Label',
							label: "Free Parameters",
							margin: "large",
							style: "list",
							controls: [
								{
									type: DefaultControls.CheckBox,
									typeName: 'CheckBox',
									name: "cov_y"
								}
							]
						}
					]
				}
			]
		},
		{
			type: DefaultControls.CollapseBox,
			typeName: 'CollapseBox',
			label: "Model Options",
			collapsed: true,
			stretchFactor: 1,
			controls: [
				{
					type: DefaultControls.LayoutBox,
					typeName: 'LayoutBox',
					margin: "large",
					style: "inline",
					controls: [
						{
							type: DefaultControls.Label,
							typeName: 'Label',
							label: "Estimation",
							margin: "large",
							style: "list",
							controls: [
								{
									type: DefaultControls.ComboBox,
									typeName: 'ComboBox',
									name: "estimator"
								},
								{
									type: DefaultControls.ComboBox,
									typeName: 'ComboBox',
									name: "likelihood",
									enable: "(estimator:ML)"
								}
							]
						},
						{
							type: DefaultControls.Label,
							typeName: 'Label',
							label: "Inferential Tests",
							margin: "large",
							style: "list",
							controls: [
								{
									type: DefaultControls.CheckBox,
									typeName: 'CheckBox',
									name: "r2test"
								},
								{
									name: "tests_Satorra.Bentler",
									type: DefaultControls.CheckBox,
									typeName: 'CheckBox',
									optionPart: "Satorra.Bentler",
									optionName: "tests"
								},
								{
									name: "tests_Yuan.Bentler",
									type: DefaultControls.CheckBox,
									typeName: 'CheckBox',
									optionPart: "Yuan.Bentler",
									optionName: "tests"
								},
								{
									name: "tests_Satterthwaite",
									type: DefaultControls.CheckBox,
									typeName: 'CheckBox',
									optionPart: "Satterthwaite",
									optionName: "tests"
								}
							]
						}
					]
				}
			]
		},
		{
			type: DefaultControls.CollapseBox,
			typeName: 'CollapseBox',
			label: "Parameters Options",
			collapsed: true,
			stretchFactor: 1,
			controls: [
				{
					type: DefaultControls.LayoutBox,
					typeName: 'LayoutBox',
					margin: "large",
					style: "inline",
					controls: [
						{
							type: DefaultControls.Label,
							typeName: 'Label',
							label: "Standard Errors",
							margin: "large",
							style: "list",
							controls: [
								{
									type: DefaultControls.RadioButton,
									typeName: 'RadioButton',
									name: "se_standard",
									optionName: "se",
									optionPart: "standard"
								},
								{
									name: "se_robust.sem",
									type: DefaultControls.RadioButton,
									typeName: 'RadioButton',
									optionName: "se",
									optionPart: "robust.sem"
								},
								{
									type: DefaultControls.RadioButton,
									typeName: 'RadioButton',
									name: "se_robust.huber.white",
									optionName: "se",
									optionPart: "robust.huber.white"
								},
								{
									type: DefaultControls.RadioButton,
									typeName: 'RadioButton',
									name: "se_boot",
									optionName: "se",
									optionPart: "boot"
								}
							]
						},
						{
							type: DefaultControls.Label,
							typeName: 'Label',
							label: "Confidence Intervals",
							margin: "large",
							style: "list",
							controls: [
								{
									type: DefaultControls.CheckBox,
									typeName: 'CheckBox',
									name: "ci"
								},
								{
									type: DefaultControls.TextBox,
									typeName: 'TextBox',
									name: "ciWidth",
									label: "Interval",
									suffix: "%",
									format: FormatDef.number,
									enable: "(ci)"
								},
								{
									type: DefaultControls.ComboBox,
									typeName: 'ComboBox',
									name: "r2ci"
								}
							]
						},
						{
							type: DefaultControls.Label,
							typeName: 'Label',
							label: "Bootstrap C.I.",
							margin: "large",
							style: "list",
							controls: [
								{
									type: DefaultControls.RadioButton,
									typeName: 'RadioButton',
									name: "bootci_bootperc",
									optionName: "bootci",
									optionPart: "perc",
									enable: "(se:boot)"
								},
								{
									type: DefaultControls.RadioButton,
									typeName: 'RadioButton',
									name: "bootci_bootnorm",
									optionName: "bootci",
									optionPart: "norm",
									enable: "(se:boot)"
								},
								{
									name: "bootci_bca.simple",
									type: DefaultControls.RadioButton,
									typeName: 'RadioButton',
									optionName: "bootci",
									optionPart: "bca.simple",
									enable: "(se:boot)"
								},
								{
									type: DefaultControls.RadioButton,
									typeName: 'RadioButton',
									name: "bootci_basic",
									optionName: "bootci",
									optionPart: "basic",
									enable: "(se:boot)"
								},
								{
									type: DefaultControls.TextBox,
									typeName: 'TextBox',
									name: "bootN",
									format: FormatDef.number,
									enable: "(se:boot)"
								}
							]
						}
					]
				},
				{
					type: DefaultControls.LayoutBox,
					typeName: 'LayoutBox',
					margin: "large",
					style: "inline",
					controls: [
						{
							type: DefaultControls.Label,
							typeName: 'Label',
							label: "Estimates",
							margin: "large",
							style: "list",
							controls: [
								{
									type: DefaultControls.CheckBox,
									typeName: 'CheckBox',
									name: "intercepts"
								},
								{
									type: DefaultControls.CheckBox,
									typeName: 'CheckBox',
									name: "showintercepts"
								},
								{
									type: DefaultControls.CheckBox,
									typeName: 'CheckBox',
									name: "indirect"
								}
							]
						},
						{
							type: DefaultControls.Label,
							typeName: 'Label',
							label: "Miscellaneous",
							margin: "large",
							style: "list",
							controls: [
								{
									type: DefaultControls.CheckBox,
									typeName: 'CheckBox',
									name: "cov_x"
								}
							]
						}
					]
				}
			]
		},
		{
			type: DefaultControls.CollapseBox,
			typeName: 'CollapseBox',
			label: "Path Diagram",
			collapsed: true,
			stretchFactor: 1,
			style: "list",
			controls: [
				{
					type: DefaultControls.LayoutBox,
					typeName: 'LayoutBox',
					margin: "large",
					stretchFactor: 1,
					style: "inline",
					controls: [
						{
							type: DefaultControls.CheckBox,
							typeName: 'CheckBox',
							name: "diagram"
						},
						{
							type: DefaultControls.Label,
							typeName: 'Label',
							label: "Paths",
							margin: "large",
							style: "list",
							controls: [
								{
									type: DefaultControls.RadioButton,
									typeName: 'RadioButton',
									name: "diag_paths_est",
									optionName: "diag_paths",
									optionPart: "est",
									enable: "(diagram)"
								},
								{
									type: DefaultControls.RadioButton,
									typeName: 'RadioButton',
									name: "diag_paths_stand",
									optionName: "diag_paths",
									optionPart: "stand",
									enable: "(diagram)"
								},
								{
									type: DefaultControls.RadioButton,
									typeName: 'RadioButton',
									name: "diag_paths_name",
									optionName: "diag_paths",
									optionPart: "name",
									enable: "(diagram)"
								},
								{
									type: DefaultControls.RadioButton,
									typeName: 'RadioButton',
									name: "diag_paths_hide",
									optionName: "diag_paths",
									optionPart: "hide",
									enable: "(diagram)"
								}
							]
						},
						{
							type: DefaultControls.Label,
							typeName: 'Label',
							label: "Show",
							margin: "large",
							style: "list",
							controls: [
								{
									type: DefaultControls.CheckBox,
									typeName: 'CheckBox',
									name: "diag_resid",
									enable: "(diagram)"
								},
								{
									type: DefaultControls.CheckBox,
									typeName: 'CheckBox',
									name: "diag_offset_labs",
									enable: "(diagram)"
								}
							]
						}
					]
				},
				{
					type: DefaultControls.LayoutBox,
					typeName: 'LayoutBox',
					margin: "large",
					stretchFactor: 1,
					style: "inline",
					controls: [
						{
							type: DefaultControls.Label,
							typeName: 'Label',
							label: "Layout",
							margin: "large",
							style: "list",
							controls: [
								{
									type: DefaultControls.ComboBox,
									typeName: 'ComboBox',
									name: "diag_type",
									enable: "(diagram)"
								},
								{
									type: DefaultControls.ComboBox,
									typeName: 'ComboBox',
									name: "diag_rotate",
									enable: "(diagram)"
								}
							]
						},
						{
							type: DefaultControls.Label,
							typeName: 'Label',
							label: "Nodes",
							margin: "large",
							style: "list",
							controls: [
								{
									type: DefaultControls.ComboBox,
									typeName: 'ComboBox',
									name: "diag_labsize",
									enable: "(diagram)"
								},
								{
									type: DefaultControls.ComboBox,
									typeName: 'ComboBox',
									name: "diag_shape",
									enable: "(diagram)"
								},
								{
									type: DefaultControls.ComboBox,
									typeName: 'ComboBox',
									name: "diag_abbrev",
									enable: "(diagram)"
								}
							]
						}
					]
				}
			]
		},
		{
			type: DefaultControls.CollapseBox,
			typeName: 'CollapseBox',
			label: "Custom Model Settings",
			collapsed: true,
			stretchFactor: 1,
			controls: [
				{
					type: DefaultControls.LayoutBox,
					typeName: 'LayoutBox',
					margin: "large",
					stretchFactor: 1,
					controls: [
						{
							type: DefaultControls.LayoutBox,
							typeName: 'LayoutBox',
							margin: "large",
							stretchFactor: 1,
							controls: [
								{
									type: DefaultControls.TargetLayoutBox,
									typeName: 'TargetLayoutBox',
									controls: [
										{
											type: DefaultControls.ListBox,
											typeName: 'ListBox',
											name: "constraints",
											height: "large",
											addButton: "Add directive",
											selectable: true,
											templateName: "linreg-block-template",
											template:
											{
												type: DefaultControls.LayoutBox,
												typeName: 'LayoutBox',
												margin: "normal",
												stretchFactor: 1,
												controls: [
													{
														type: DefaultControls.TextBox,
														typeName: 'TextBox',
														name: "randblockList",
														valueFilter: "unique",
														stretchFactor: 0.5,
														borderless: true,
														height: "auto",
														ghostText: "drag term here"
													}
												]
											}											
										}
									]
								}
							]
						},
						{
							type: DefaultControls.LayoutBox,
							typeName: 'LayoutBox',
							margin: "large",
							style: "inline",
							controls: [
								{
									type: DefaultControls.Label,
									typeName: 'Label',
									label: "Information",
									controls: [
										{
											type: DefaultControls.LayoutBox,
											typeName: 'LayoutBox',
											margin: "large",
											controls: [
												{
													type: DefaultControls.CheckBox,
													typeName: 'CheckBox',
													name: "showlabels"
												},
												{
													type: DefaultControls.CheckBox,
													typeName: 'CheckBox',
													name: "constraints_examples"
												}
											]
										}
									]
								},
								{
									type: DefaultControls.Label,
									typeName: 'Label',
									label: "Constraints Tests",
									controls: [
										{
											type: DefaultControls.LayoutBox,
											typeName: 'LayoutBox',
											margin: "large",
											controls: [
												{
													type: DefaultControls.CheckBox,
													typeName: 'CheckBox',
													name: "scoretest"
												},
												{
													type: DefaultControls.CheckBox,
													typeName: 'CheckBox',
													name: "cumscoretest"
												}
											]
										}
									]
								}
							]
						}
					]
				}
			]
		},
		{
			type: DefaultControls.CollapseBox,
			typeName: 'CollapseBox',
			label: "Multigroup Options",
			collapsed: true,
			stretchFactor: 1,
			controls: [
				{
					type: DefaultControls.LayoutBox,
					typeName: 'LayoutBox',
					margin: "large",
					style: "inline",
					controls: [
						{
							type: DefaultControls.Label,
							typeName: 'Label',
							label: "Equal across groups",
							margin: "large",
							style: "list",
							controls: [
								{
									name: "group.equal_regressions",
									type: DefaultControls.CheckBox,
									typeName: 'CheckBox',
									optionPart: "regressions",
									optionName: "group.equal"
								},
								{
									name: "group.equal_intercepts",
									type: DefaultControls.CheckBox,
									typeName: 'CheckBox',
									optionPart: "intercepts",
									optionName: "group.equal"
								},
								{
									name: "group.equal_residuals",
									type: DefaultControls.CheckBox,
									typeName: 'CheckBox',
									optionPart: "residuals",
									optionName: "group.equal"
								},
								{
									name: "group.equal_residual.covariances",
									type: DefaultControls.CheckBox,
									typeName: 'CheckBox',
									optionName: "group.equal",
									optionPart: "residual.covariances"
								}
							]
						}
					]
				}
			]
		},
		{
			type: DefaultControls.CollapseBox,
			typeName: 'CollapseBox',
			label: "Factors Coding",
			collapsed: true,
			stretchFactor: 1,
			controls: [
				{
					type: DefaultControls.ListBox,
					typeName: 'ListBox',
					name: "contrasts",
					stretchFactor: 1,
					showColumnHeaders: false,
					columns: [
						{
							name: "var",
							label: null,
							selectable: false,
							stretchFactor: 1,
							maxWidth: 300,
							template:
							{
								type: DefaultControls.VariableLabel,
								typeName: 'VariableLabel'
							}							
						},
						{
							name: "type",
							label: null,
							selectable: false,
							stretchFactor: 0.5,
							template:
							{
								type: DefaultControls.ComboBox,
								typeName: 'ComboBox'
							}							
						}
					]
				},
				{
					type: DefaultControls.CheckBox,
					typeName: 'CheckBox',
					name: "showContrastCode"
				}
			]
		},
		{
			type: DefaultControls.CollapseBox,
			typeName: 'CollapseBox',
			label: "Continuous Variables Scaling",
			collapsed: true,
			stretchFactor: 1,
			controls: [
				{
					type: DefaultControls.ListBox,
					typeName: 'ListBox',
					name: "scaling",
					stretchFactor: 1,
					showColumnHeaders: false,
					columns: [
						{
							name: "var",
							label: null,
							selectable: false,
							stretchFactor: 1,
							maxWidth: 300,
							template:
							{
								type: DefaultControls.VariableLabel,
								typeName: 'VariableLabel'
							}							
						},
						{
							name: "type",
							label: null,
							selectable: false,
							stretchFactor: 0.5,
							template:
							{
								type: DefaultControls.ComboBox,
								typeName: 'ComboBox'
							}							
						}
					]
				}
			]
		}
	]
});

module.exports = { view : view, options: options };

},{"./pathj.events":1}]},{},[2])(2)
});
